﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace SaveMeta_Creator
{
    public partial class Form1 : Form
    {
        public byte[] MetaData
        {
            get;
            set;
        }

        public byte[] Header
        {
            get;
            set;
        }

        public byte[] Footer
        {
            get;
            set;
        }

        public string OpenedFile
        {
            get;
            set;
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //Creating the UTF8 Encoder for Byte Editing
            System.Text.UTF8Encoding encoding = new UTF8Encoding();
            
            //Converting String
            string Text = this.textBox1.Text;

            //Creating Header
            byte[] Header = new byte[12] { 0xFF, 0xFE, 0x4E, 0x00, 0x61, 0x00, 0x6D, 0x00, 0x65, 0x00, 0x3D, 0x00 };            

            //Creating Footer
            byte[] Footer = new byte[4] { 0x0D, 0x00, 0x0A, 0x00 };            

            //Creating Data Shell for Bytes
            string MetaData = (Text);
            byte[] Data = new byte[(Text.Length * 2)];
            //Creating Indecies...
            int CharIndex = 0;
            int ByteIndex = 0;

            //Adding Bytes
            foreach (char Character in MetaData)
            {
                //Converting the Character to a Byte code
                byte bytedata = encoding.GetBytes(MetaData)[CharIndex];
                //Adding Bytes
                Data[ByteIndex] = bytedata;
                ByteIndex++;
                Data[ByteIndex] = 0x00;
                ByteIndex++;
                CharIndex++;
            }

            //Piecing Together
            this.Header = Header;
            this.MetaData = Data;
            this.Footer = Footer;

            //Success
            MessageBox.Show("Successfully Calculated... Ready to Save!", "Success", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void menuItem10_Click(object sender, EventArgs e)
        {
            //Create SaveFileDialog
            SaveFileDialog SaveDialog = new SaveFileDialog();
            //Setting Properties
            SaveDialog.Title = "Save SaveMeta file...";
            SaveDialog.FileName = "SaveMeta";
            SaveDialog.Filter = "SaveMeta Files (*.xbx)|*.xbx";
            //Saving Process
            if (SaveDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                //Save
                SaveFile(SaveDialog.FileName);
            }
            //Cleaning Up
            SaveDialog.Dispose();
        }
        
        private void menuItem3_Click(object sender, EventArgs e)
        {
            //Create OpenFileDialog Reference
            OpenFileDialog OpenDialog = new OpenFileDialog();
            //Seting OpenDialog's Properties
            OpenDialog.Title = "Open SaveMeta file...";
            OpenDialog.FileName = "";
            OpenDialog.Filter = "SaveMeta Files (*.xbx)|*.xbx";
            //Showing
            if (OpenDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                //Creating FileStream
                FileStream File = new FileStream(OpenDialog.FileName, FileMode.Open);
                //Create Binary Writer
                BinaryReader BReader = new BinaryReader(File);
                //Create our Byte array
                byte[] bytes;
                //Math Time!
                int x = Convert.ToInt32(File.Length); //File size
                int y; //Title/Name Length
                int z; //Ending Position
                int a = 12; //Start position
                //Equation for finding the Name block
                //x - 12 = y + 4
                //Equation for finding the Ending position
                //x - 4 = z
                //Do the math
                y = (60 - 12);
                y = (y + 4);
                z = (x - 4);
                //Lets see what we get!
                File.Position = a;
                bytes = BReader.ReadBytes(y);
                //Great, no errors lets clean up
                BReader.Close();
                //Now we need to remove the spaces between each character.
                byte[] NewBytes = new byte[(bytes.Length / 2)];
                //Create index
                int actindex = 0;
                int index = 0;
                //It's looping time!
                foreach (byte bt in NewBytes)
                {
                    NewBytes[actindex] = bytes[index];
                    actindex++;
                    index++; index++;
                }

                //Changing Poperties
                Header = new byte[12] { 0xFF, 0xFE, 0x4E, 0x00, 0x61, 0x00, 0x6D, 0x00, 0x65, 0x00, 0x3D, 0x00 };
                Footer = new byte[4] { 0x0D, 0x00, 0x0A, 0x00 };
                MetaData = NewBytes;

                //Load bytes to characters
                System.Text.UTF8Encoding Encoder = new UTF8Encoding();
                string Title = Encoder.GetString(MetaData);
                Title = Title.Replace("\r\n", "");
                //Setting textbox
                this.textBox1.Text = Title;
                //Setting OpenFile
                this.OpenedFile = OpenDialog.FileName;
            }
            OpenDialog.Dispose();
        }

        private void menuItem9_Click(object sender, EventArgs e)
        {
            if (this.OpenedFile != null)
            {
                //Save...
                SaveFile(OpenedFile);
            }
        }

        private void menuItem6_Click(object sender, EventArgs e)
        {
            //Exit Program
            Application.Exit();
        }

        private void menuItem2_Click(object sender, EventArgs e)
        {
            //About
            MessageBox.Show("Created by Mike Mattera, Click16.\nCopyright (C) 2011 Potential Software",
                "About", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        public void SaveFile(string FilePath)
        {
            //Create FileStream
            FileStream File = new FileStream(FilePath, FileMode.Create);
            //Create Binary Writer
            BinaryWriter BWriter = new BinaryWriter(File);
            try
            {
                //Writing Bytes
                BWriter.Write(Header); BWriter.Write(MetaData); BWriter.Write(Footer);
                //Cleaning Up...
                BWriter.Close();
                File.Close();
            }
            catch (ArgumentNullException)
            {
                MessageBox.Show("Click Generate before saving...\n(If you continue to see this message, contact me...)", "Facepalm.",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                //Close File Accessors
                File.Close();
                BWriter.Close();
            }
            catch(Exception e)
            {
                //errorbox
                MessageBox.Show("An unexpected error occured. Please make sure that no other programs are trying to access this file.\n\n\n" +
                e.Message,
                    "Error!", MessageBoxButtons.OK, MessageBoxIcon.Error);
                //Close File Accessors
                File.Close();
                BWriter.Close();
            }
        }
    }
}
